<?php
ini_set('display_errors', 1);

require_once '../../../resources/base_path_include.php';

require_once $base_path_to_learning_resources  . "includes/connect.php"; // use require for mandatory files
require_once $base_path_to_learning_resources . 'lib/function.php';
require_once $base_path_to_learning_resources . 'lib/validate_api_signature.php';

//valdation file
require_once $base_path_to_learning_resources . 'lib/validate_function.php';
require_once $base_path_to_learning . '/user_management/check_username_availability.php';
require_once $base_path_to_learning . 'user_management/authenticate.php';
require_once $base_path_to_learning . 'admin_api/academic_session/functions/registration_functions.php';
require_once $base_path_to_learning . 'admin_api/modules/students/student_functions.php';
require_once $base_path_to_learning . 'functions/common_functions.php';
//dynemic db
require_once $base_path_to_learning_resources . 'includes/specific_db_config.php';

require_once $base_path_to_learning . "vendor/autoload.php";
require_once $base_path_to_learning_resources . 'lib/bucket_functions/bucket_functions.php';
require_once $base_path_to_learning_resources . 'includes/aws_bucket_config.php';

use Aws\S3\S3Client;
use Aws\S3\Exception\S3Exception;

$postdata = json_decode(file_get_contents("php://input"), true);

if (
    !isset($postdata['function_type']) or !checkIfIssetAndNotEmpty($postdata['function_type']) or
    !isset($postdata['api_signature']) or !checkIfIssetAndNotEmpty($postdata['api_signature']) or
    !isset($postdata['jwt_token']) or !checkIfIssetAndNotEmpty($postdata['jwt_token'])

) {
    errorreturn("All * fields are required.");
}

validateApiSignature($postdata['api_signature']);

$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$username = $jwt_validate->data->username;
$role = $jwt_validate->data->role;
$branch_id = $jwt_validate->data->branch_id;
$institution_id = $jwt_validate->data->institution_id;

$specific_db_name = validateUserAccess($conn_rjllearning, $userid, $role, $workspace_id,["teacher"], null);
if (!$specific_db_name) {
    errorreturn('Access denied.');
} else {
    $conn_rjllearning_specific = dynamicDbConnection($specific_db_name);
}

require_once $base_path_to_learning . 'user_management/user_versioning.php';

$version = isset($_POST['version']) ? $_POST['version'] : (isset($postdata['version']) ? $postdata['version'] : null);
$updated_time = isset($_POST['updated_time']) ? $_POST['updated_time'] : (isset($postdata['updated_time']) ? $postdata['updated_time'] : null);

$response = user_data_refresh($conn_rjllearning, $conn_rjllearning_specific,$version, $updated_time, $userid, $institution_id);

function GetStudentsSibling($conn_rjllearning_specific, $institution_id, $branch_id, $search_string, $additionaldata)
{
    $sql = "SELECT COUNT(id) AS total_rows FROM students WHERE  institution_id = ? AND branch_id = ? and can_activate = 1";
    $array_params = [$institution_id, $branch_id];

    $validate_student = $conn_rjllearning_specific->prepare($sql);
    $validate_student->execute($array_params);

    $result_total = $validate_student->fetchAll();
    $totalrows = $result_total[0]['total_rows'];


    $sql = "SELECT ";
    $array_counter = 0;
    foreach ($additionaldata as $column_name) {
        if ($array_counter == 0) {
            $sql .= $column_name;
        } else {
            $sql .= ", " . $column_name;
        }
        $array_counter++;
    }

    $sql .= " FROM students";
    $sql .= " WHERE institution_id = ? AND branch_id = ?";

    $array_params = [$institution_id, $branch_id];

    if ($search_string != null) {
        $sql .= " AND admission_number = ? ";
        $array_params[] = $search_string;
    }
    $sql .= " order by id desc, date_added desc ";
    // echo $sql;die();
    $stmt = $conn_rjllearning_specific->prepare($sql);
    $stmt->execute($array_params);
    $result = $stmt->fetchAll();

    $array_return = [];
    foreach ($result as $res) {
        $fieldarray = [];
        foreach ($additionaldata as $column_name) {

            // For all other columns
            $fieldarray[$column_name] = $res[$column_name];
        }
        array_push($array_return, $fieldarray);
    }

    //return $array_return;
    if (count($result) < 50) {

        return array('total_students' => $totalrows, 'students_info' => $array_return, 'maxreach' => 1);
    } else {
        return array('total_students' => $totalrows, 'students_info' => $array_return, 'maxreach' => 0);
    }
}

if ($postdata['function_type']  == "fetch_students_admission_no") {


    if (isset($postdata['search_string']) and !empty($postdata['search_string'])) {
        $search_string = trim($postdata['search_string']);
    } else {
        $search_string = null;
    }

    $additionaldata = array();
    // $additionaldata = ['id', 'stock_name', 'current_qty', 'parent_group'];
    //$additionaldata = ['id','institution_id','branch_id','admission_number','username','name','mobile','email','dob','gender','fathername','mothername','address_line_1','city','pincode','caste','nationality','nationality_proof_number'];
    $additionaldata = ['id', 'admission_number', 'name', 'mobile', 'email'];

    // $additionaldata = array_merge($additionaldata, $postdata['additional_data']);


    $success['data'] = GetStudentsSibling($conn_rjllearning_specific, $institution_id, $branch_id, $search_string, $additionaldata);
    successreturn($success);
}
